=== debian/changelog ===
ros-melodic-ariles-ros (1.3.2-1bionic) bionic; urgency=high

  * Sync to 1.3.2 (bugfixes).

 -- Alexander Sherikov <asherikov@yandex.com>  Sun, 15 Dec 2019 23:00:00 -0000

ros-melodic-ariles-ros (1.3.1-1bionic) bionic; urgency=high

  * Sync to 1.3.1
  * Fix bugs in cmake scripts.
  * Enable 'array' bridge.

 -- Alexander Sherikov <asherikov@yandex.com>  Tue, 22 Oct 2019 22:00:00 -0000

ros-melodic-ariles-ros (1.1.5-1bionic) bionic; urgency=high

  * Sync to 1.1.5.
  * Remove setup.sh and other helpers from the package.
  * More thorough testing.

 -- Alexander Sherikov <asherikov@yandex.com>  Mon, 03 Jun 2019 22:00:00 -0000

ros-melodic-ariles-ros (1.1.1-1bionic) bionic; urgency=high

  * Sync to 1.1.1, added README.md
  * Initial ROS release.

 -- Alexander Sherikov <asherikov@yandex.com>  Thu, 18 Apr 2019 22:00:00 -0000
