=== debian/control ===
Source: ros-melodic-ariles-ros
Section: misc
Priority: optional
Maintainer: Alexander Sherikov <asherikov@yandex.com>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, libeigen3-dev, libyaml-cpp-dev, ros-melodic-catkin, ros-melodic-roscpp
Homepage: 
Standards-Version: 3.9.2

Package: ros-melodic-ariles-ros
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libeigen3-dev, libyaml-cpp-dev, ros-melodic-roscpp
Description: Catkin package Ariles serialization/configuration library
